#!/bin/sh

#####################################################################
# Return:
#   -1: sdcard is not existed.
#   0:  /system/init/sdcard.info not exist, need bind sdcard.
#   1:  sdcard bind normally.
#   2:  sdcard formatted, or changed.
#####################################################################

## /system/init/目录下SD卡绑定信息 
FILEPATH_SYSTEM_SDCARDINFO="/system/init/sdcard.info"

SD_EXIST=`mount | grep "/dev/mmcblk" | wc -l`
#echo -e "-------- sd_exist: $SD_EXIST --------"
if [ ${SD_EXIST} -eq 0 ];then
    echo "-1"
    exit 0
fi

if [ ! -f ${FILEPATH_SYSTEM_SDCARDINFO} ];then
    echo "0"
    exit 0
fi

#SD_UUID=`blkid | grep "/dev/mmcblk" | awk -F "UUID=" '{print $2}'`
SD_UUID=`blkid /dev/mmcblk?p? | grep "/dev/mmcblk" | awk -F "UUID=" '{print $2}'`
FILE_UUID=`cat ${FILEPATH_SYSTEM_SDCARDINFO} | grep "UUID"  | awk -F "UUID=" '{print $2}'`
#echo -e "==> SD_UUID: ${SD_UUID}, FILE_UUID: ${FILE_UUID}"
if [ "${SD_UUID}" = "${FILE_UUID}" ];then
    echo "1" ## sdcard bind normally.
    exit 0
else
    echo "2" ## sdcard formatted or changed.
    exit 0
fi

