#!/bin/sh
SILIENCE_FLAG="/system/init/silence.flag"
###################### blue ##########################
if [ ! -d /sys/class/gpio/gpio7 ]; then
    /bin/echo 7 > /sys/class/gpio/export
fi
DIRECTION=`cat /sys/class/gpio/gpio7/direction`
if [ "$DIRECTION" != "out" ]; then
    echo -e "==== gpio7 direction: $DIRECTION, change to 'out' ===="
    /bin/echo out > /sys/class/gpio/gpio7/direction
fi

####################### green ########################
if [ ! -d /sys/class/gpio/gpio60 ]; then  
    /bin/echo 60 > /sys/class/gpio/export 
fi
DIRECTION=`cat /sys/class/gpio/gpio60/direction` 
if [ "$DIRECTION" != "out" ]; then
    echo -e "==== gpio60 direction: $DIRECTION, change to 'out' ====" 
    /bin/echo out > /sys/class/gpio/gpio60/direction 
fi

####################### red  #########################
if [ ! -d /sys/class/gpio/gpio62 ]; then  
    /bin/echo 62 > /sys/class/gpio/export 
fi
DIRECTION=`cat /sys/class/gpio/gpio62/direction` 
if [ "$DIRECTION" != "out" ]; then
    echo -e "==== gpio62 direction: $DIRECTION, change to 'out' ====" 
    /bin/echo out > /sys/class/gpio/gpio62/direction 
fi

Blue_Off()
{
	/bin/echo 0 > /sys/class/gpio/gpio7/value
}
Blue_On()
{
	/bin/echo 1 > /sys/class/gpio/gpio7/value
}
Red_Off()
{
	/bin/echo 0 > /sys/class/gpio/gpio62/value
}
Red_On()
{
	/bin/echo 1 > /sys/class/gpio/gpio62/value
}
Green_Off()
{
	/bin/echo 0 > /sys/class/gpio/gpio60/value
}
Green_On()
{
	/bin/echo 1 > /sys/class/gpio/gpio60/value
}

ALL_On()
{
	Blue_On
	Red_On
	Green_On
}
ALL_Off()
{
	Blue_Off
	Red_Off
	Green_Off
}

UPDATING_FLAG="/tmp/led_updating.flag"
SYSWARNING_FLAG="/tmp/led_syswarning.flag"
SCANNING_FLAG="/tmp/led_scanning.flag"
CONNECTING_FLAG="/tmp/led_connecting.flag"
CONNECTERR_FLAG="/tmp/led_connecterr.flag"
ALLOFF_FLAG="/tmp/led_alloff.flag"

ALL_Off
rm -rf /tmp/led_*
while [ "1" == "1" ]
do
	if [ -f $SCANNING_FLAG ];
	then	
		ALL_Off
		usleep 700000

		Red_On
		usleep 800000
		continue
	fi

	if [ -f $UPDATING_FLAG ];
	then	
		ALL_Off
		usleep 700000

		Red_On
		Green_On
		usleep 800000
		continue
	fi

	if [ -f $ALLOFF_FLAG ];
	then	
		ALL_Off
		sleep 1
		continue
	fi

	if [ -f $CONNECTING_FLAG ];
	then	
		ALL_Off
		usleep 1200000

		Blue_On
		usleep 300000
		continue
	fi

	if [ -f $CONNECTERR_FLAG ];
	then	
		Blue_Off
		Red_On
		Green_Off
		sleep 1
		continue
	fi
	ALL_Off
	sleep 1
	continue
done
